// import Auth from '@/views/layout/auth'

// type metaType = {
//   isRegister: boolean
// }

export default [
  {
    path: '/',
    component: () => import('@/views/home/index'),
    meta: {
      title: '首页',
      highlightPath: '/home',
      isdark: false
    }
  },
  {
    path: '/home',
    name: 'home',
    component: () => import('@/views/home/index'),
    meta: {
      title: '首页',
      highlightPath: '/home',
      isdark: false
    }
  },
  {
    path: '/downLoad',
    name: 'downLoad',
    component: () => import('@/views/downLoad/index'),
    meta: {
      title: '下载',
      highlightPath: '/downLoad',
      isdark: true
    }
  },
  {
    path: '/albumibrary',
    name: 'albumibrary',
    component: () => import('@/views/albumLibrary/index'),
    meta: {
      title: '专辑',
      highlightPath: '/albumibrary',
      index: 2,
      isdark: false
    }
  },
  {
    path: '/musicLibrary',
    name: 'musicLibrary',
    component: () => import('@/views/musicLibrary/index'),
    meta: {
      title: '曲谱',
      highlightPath: '/musicLibrary',
      index: 2,
      isdark: false
    }
  },
  {
    path: '/muiscDetial',
    name: 'muiscDetial',
    component: () => import('@/views/muiscDetial/index'),
    meta: {
      title: '曲谱详情',
      highlightPath: '/musicLibrary',
      index: 2,
      isdark: true
    }
  },

  {
    path: '/searchdetail',
    name: 'searchdetail',
    component: () => import('@/views/musicLibrary/searchdetail'),
    meta: {
      title: '搜索',
      index: 3,
      highlightPath: '/musicLibrary',
      isdark: true
    }
  },
  {
    path: '/albumDetail',
    name: 'albumDetail',
    component: () => import('@/views/albumDetail'),
    meta: {
      title: '专辑详情',
      index: 3,
      highlightPath: '/musicLibrary',
      isdark: true
    }
  },
  {
    path: '/videoDetailList',
    name: 'videoDetailList',
    component: () => import('@/views/videoDetailList'),
    meta: {
      title: '视频课',
      index: 3,
      highlightPath: '/videoDetailList',
      isdark: false
    }
  },
  {
    path: '/videoDetail',
    name: 'videoDetail',
    component: () => import('@/views/videoDetailList/videoDetail'),
    meta: {
      title: '视频课详情',
      index: 3,
      highlightPath: '/videoDetailList',
      isdark: true
    }
  },
  //

  {
    path: '/teacherAuth',
    name: 'teacherAuth',
    component: () => import('@/views/role-auth/teacherAuth'),
    meta: {
      title: '达人认证',
      isdark: true
    }
  },
  {
    path: '/musicAuth',
    name: 'musicAuth',
    component: () => import('@/views/role-auth/musicAuth'),
    meta: {
      title: '音乐人认证',
      isdark: true
    }
  },
  {
    path: '/userInfo',
    name: 'userInfo',
    meta: { title: '用户信息', index: 5, isdark: true },
    component: () => import('@/views/user-info/index'),
    redirect: '/userInfo/practiceSetting',
    children: [
      {
        path: '/userInfo/practiceSetting',
        name: 'userInfoPracticeSetting',
        component: () => import('@/views/user-info/practice-setting'),
        meta: { title: '陪练课', index: 2, isdark: true }
      },
      {
        path: '/userInfo/liveClass',
        name: 'userInfoLiveClass',
        component: () => import('@/views/user-info/live-class'),
        meta: { title: '直播课', index: 3, isdark: true }
      },
      {
        path: '/userInfo/liveOperation',
        name: 'userInfoLiveOperation',
        component: () => import('@/views/user-info/live-operation'),
        meta: {
          title: '直播课',
          index: 4,
          hidden: true,
          activeMenu: 'userInfoLiveClass',
          isdark: true
        }
      },
      {
        path: '/userInfo/videoClass',
        name: 'userInfoVideoClass',
        component: () => import('@/views/user-info/video-class'),
        meta: { title: '视频课', index: 4, isdark: true }
      },
      {
        path: '/userInfo/videoOperation',
        name: 'userInfoVideoOperation',
        component: () => import('@/views/user-info/video-operation'),
        meta: {
          title: '视频课',
          index: 4,
          hidden: true,
          activeMenu: 'userInfoVideoClass',
          isdark: true
        }
      },
      {
        path: '/userInfo/musicClass',
        name: 'userInfoMusicClass',
        component: () => import('@/views/user-info/music-class'),
        meta: { title: '上传曲谱', index: 6, isdark: true }
      },
      {
        path: '/userInfo/musicOperation',
        name: 'userInfoMusicOperation',
        component: () => import('@/views/user-info/music-operation'),
        meta: {
          title: '上传曲谱',
          index: 6,
          hidden: true,
          activeMenu: 'userInfoMusicClass',
          isdark: true
        }
      },
      {
        path: '/userInfo/myCollect',
        name: 'userInfoMyCollect',
        component: () => import('@/views/student-info/my-score'),
        meta: {
          title: '我的曲谱',
          index: 5,
          hidden: false,
          activeMenu: 'userInfoMyCollect',
          isdark: true
        }
      },
      {
        path: '/userInfo/myFans',
        name: 'userInfoMyFans',
        component: () => import('@/views/user-info/my-fans'),
        meta: { title: '我的粉丝', index: 4, hidden: true, isdark: true }
      },
      {
        path: '/userInfo/openLive',
        name: 'userInfoOpenLive',
        component: () => import('@/views/user-info/open-live'),
        meta: {
          title: '开通直播',
          index: 4,
          hidden: true,
          activeMenu: 'userInfoLiveClass',
          isdark: true
        }
      }
    ]
  },
  {
    path: '/studentInfo',
    name: 'studentInfo',
    component: () => import('@/views/student-info'),
    meta: { title: '用户信息', index: 5, isdark: true },
    redirect: '/studentInfo/myScore',
    children: [
      {
        path: '/studentInfo/myScore',
        name: 'studentInfoMyScore',
        component: () => import('@/views/student-info/my-score'),
        meta: { title: '我的曲谱', index: 5, isdark: true }
      },
      {
        path: '/studentInfo/myFollow',
        name: 'studentInfoMyFollow',
        component: () => import('@/views/student-info/my-follow'),
        meta: { title: '我关注的老师', index: 5, hidden: true, isdark: true }
      }
    ]
  },
  {
    path: '/404',
    name: '404',
    component: () => import('@/views/404'),
    meta: { title: '404', isdark: true }
  },
  {
    path: '/:pathMatch(.*)*',
    component: () => import('@/views/404'),
    meta: {
      title: '404 Not Fund',
      isdark: true
    }
  }
]
